c------------------------------------------------------------------------
      subroutine inifit
c
c..... this subroutine simply reads the fit parameters and should be 
c..... referenced before the potential is called fot the first time
c..... the fitting parameters are stored in the common blocks common/cparm/
c......and common/cint/
c
      implicit real*8(a-h,o-z)
      parameter(nmx=200)
      common/cparm/ a(nmx),p(nmx),ma,np
      common/cint/ ix(nmx),iy(nmx),iz(nmx),mmax
	  open(1,file='three.param',status='old')
	  i=1
      rewind 1
10    read(1,*,end=100) nparm,ix(i),iy(i),iz(i),a(i)
      i=i+1
	  goto 10
100   ma=i-1
      close(1)
      m=ix(ma-6)
      mmax=m+1
	  open(1,file='two.param',status='old')
	  i=1
      rewind 1
11     read(1,*,end=111)p(i)
      i=i+1
	  goto 11
111   np=i-1
      close(1)
      return
      end
c--------------------------------------------------------------------------
      subroutine sw(x,y,z,v)
      implicit real*8(a-h,o-z)
      parameter(nmx=200)
      common/cparm/ a(nmx),p(nmx),ma,np
      common/cint/ ix(nmx),iy(nmx),iz(nmx),mmax
      dimension xex(0:mmax),xey(0:mmax),xez(0:mmax)
c
c.... calculates potential of the Stark-Werner surface for F+H2
c....  x,y,z(Input) are the internal coordinates of F-H1-H2 :
c....  x = r(F-H1) y= r(H1-H2) z= r(F-H2)
c....  v(output) is the potential in a.u.

c.... initializing the non-linear parameters
      b1 = a(ma-5)
      b2 = a(ma-4)
      b3 = a(ma-3)
      x0 = a(ma-2)
      y0 = a(ma-1)
      z0 = a(ma)
      fit = 0.0d0
      xexpon = b1*(x-x0)
      yexpon = b2*(y-y0)
      zexpon = b3*(z-z0)
      exponx=dexp(-xexpon)
      expony=dexp(-yexpon)
      exponz=dexp(-zexpon)
      fex = x*exponx
      fey = y*expony
      fez = z*exponz
      xex(0)=1
      xey(0)=1
      xez(0)=1
      xex(1)=fex
      xey(1)=fey
      xez(1)=fez
      do m=2,mmax-1
	 xex(m)=xex(m-1)*fex
	 xey(m)=xey(m-1)*fey
	 xez(m)=xez(m-1)*fez
       enddo


c
c.... Aguado-Paniagua-Fit for the threebody-terms
c.... Method seems to be a bit confusing
c.... But this type of programming was chosen to avoid
c.... terms like x**b(i)*y**c(j)*z**d(k), which
c.... cost much more CPU-time !
c
      do 1010 i=1,ma-6
       fit=fit+xex(ix(i))*xey(iy(i))*xez(iz(i))*a(i)
1010  continue
c
c.... Two-Body-Potential : Extended-Rydberg-Functional
c
      xr = x-p(3)
      yr = y-p(9)
      zr = z-p(3)
      xr2=xr*xr
      xr3=xr2*xr
      yr2=yr*yr
      yr3=yr2*yr
      zr2=zr*zr
      zr3=zr2*zr
      fx = dexp(-p(2)*xr)
      fy = dexp(-p(8)*yr)
      fz = dexp(-p(2)*zr)
      ux = -p(1)*(1.0d0+p(2)*xr+p(4)*xr2+p(5)*xr3)
      uy = -p(7)*(1.0d0+p(8)*yr+p(10)*yr2+p(11)*yr3)
      uz = -p(1)*(1.0d0+p(2)*zr+p(4)*zr2+p(5)*zr3)
      xval=ux*fx+p(6)
      yval=uy*fy+p(12)
      zval=uz*fz+p(6)
c
c... Resulting Potential in atomic untis
c
      v=fit+xval+yval+zval
      return
      end
c------------------------------------------------------------------------
